<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfGoodFullInfo ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfGoodFullInfo
 * @subpackage Arrays
 */
class ArrayOfGoodFullInfo extends AbstractStructArrayBase
{
    /**
     * The GoodFullInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\GoodFullInfo[]
     */
    public $GoodFullInfo;
    /**
     * Constructor method for ArrayOfGoodFullInfo
     * @uses ArrayOfGoodFullInfo::setGoodFullInfo()
     * @param \StructType\GoodFullInfo[] $goodFullInfo
     */
    public function __construct(array $goodFullInfo = array())
    {
        $this
            ->setGoodFullInfo($goodFullInfo);
    }
    /**
     * Get GoodFullInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\GoodFullInfo[]|null
     */
    public function getGoodFullInfo()
    {
        return isset($this->GoodFullInfo) ? $this->GoodFullInfo : null;
    }
    /**
     * This method is responsible for validating the values passed to the setGoodFullInfo method
     * This method is willingly generated in order to preserve the one-line inline validation within the setGoodFullInfo method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateGoodFullInfoForArrayConstraintsFromSetGoodFullInfo(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfGoodFullInfoGoodFullInfoItem) {
            // validation for constraint: itemType
            if (!$arrayOfGoodFullInfoGoodFullInfoItem instanceof \StructType\GoodFullInfo) {
                $invalidValues[] = is_object($arrayOfGoodFullInfoGoodFullInfoItem) ? get_class($arrayOfGoodFullInfoGoodFullInfoItem) : sprintf('%s(%s)', gettype($arrayOfGoodFullInfoGoodFullInfoItem), var_export($arrayOfGoodFullInfoGoodFullInfoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The GoodFullInfo property can only contain items of type \StructType\GoodFullInfo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set GoodFullInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\GoodFullInfo[] $goodFullInfo
     * @return \ArrayType\ArrayOfGoodFullInfo
     */
    public function setGoodFullInfo(array $goodFullInfo = array())
    {
        // validation for constraint: array
        if ('' !== ($goodFullInfoArrayErrorMessage = self::validateGoodFullInfoForArrayConstraintsFromSetGoodFullInfo($goodFullInfo))) {
            throw new \InvalidArgumentException($goodFullInfoArrayErrorMessage, __LINE__);
        }
        if (is_null($goodFullInfo) || (is_array($goodFullInfo) && empty($goodFullInfo))) {
            unset($this->GoodFullInfo);
        } else {
            $this->GoodFullInfo = $goodFullInfo;
        }
        return $this;
    }
    /**
     * Add item to GoodFullInfo value
     * @throws \InvalidArgumentException
     * @param \StructType\GoodFullInfo $item
     * @return \ArrayType\ArrayOfGoodFullInfo
     */
    public function addToGoodFullInfo(\StructType\GoodFullInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\GoodFullInfo) {
            throw new \InvalidArgumentException(sprintf('The GoodFullInfo property can only contain items of type \StructType\GoodFullInfo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->GoodFullInfo[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\GoodFullInfo|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\GoodFullInfo|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\GoodFullInfo|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\GoodFullInfo|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\GoodFullInfo|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string GoodFullInfo
     */
    public function getAttributeName()
    {
        return 'GoodFullInfo';
    }
}
