<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRadTaeidDataCnt ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfRadTaeidDataCnt
 * @subpackage Arrays
 */
class ArrayOfRadTaeidDataCnt extends AbstractStructArrayBase
{
    /**
     * The RadTaeidDataCnt
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\RadTaeidDataCnt[]
     */
    public $RadTaeidDataCnt;
    /**
     * Constructor method for ArrayOfRadTaeidDataCnt
     * @uses ArrayOfRadTaeidDataCnt::setRadTaeidDataCnt()
     * @param \StructType\RadTaeidDataCnt[] $radTaeidDataCnt
     */
    public function __construct(array $radTaeidDataCnt = array())
    {
        $this
            ->setRadTaeidDataCnt($radTaeidDataCnt);
    }
    /**
     * Get RadTaeidDataCnt value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\RadTaeidDataCnt[]|null
     */
    public function getRadTaeidDataCnt()
    {
        return isset($this->RadTaeidDataCnt) ? $this->RadTaeidDataCnt : null;
    }
    /**
     * This method is responsible for validating the values passed to the setRadTaeidDataCnt method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRadTaeidDataCnt method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRadTaeidDataCntForArrayConstraintsFromSetRadTaeidDataCnt(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfRadTaeidDataCntRadTaeidDataCntItem) {
            // validation for constraint: itemType
            if (!$arrayOfRadTaeidDataCntRadTaeidDataCntItem instanceof \StructType\RadTaeidDataCnt) {
                $invalidValues[] = is_object($arrayOfRadTaeidDataCntRadTaeidDataCntItem) ? get_class($arrayOfRadTaeidDataCntRadTaeidDataCntItem) : sprintf('%s(%s)', gettype($arrayOfRadTaeidDataCntRadTaeidDataCntItem), var_export($arrayOfRadTaeidDataCntRadTaeidDataCntItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RadTaeidDataCnt property can only contain items of type \StructType\RadTaeidDataCnt, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RadTaeidDataCnt value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\RadTaeidDataCnt[] $radTaeidDataCnt
     * @return \ArrayType\ArrayOfRadTaeidDataCnt
     */
    public function setRadTaeidDataCnt(array $radTaeidDataCnt = array())
    {
        // validation for constraint: array
        if ('' !== ($radTaeidDataCntArrayErrorMessage = self::validateRadTaeidDataCntForArrayConstraintsFromSetRadTaeidDataCnt($radTaeidDataCnt))) {
            throw new \InvalidArgumentException($radTaeidDataCntArrayErrorMessage, __LINE__);
        }
        if (is_null($radTaeidDataCnt) || (is_array($radTaeidDataCnt) && empty($radTaeidDataCnt))) {
            unset($this->RadTaeidDataCnt);
        } else {
            $this->RadTaeidDataCnt = $radTaeidDataCnt;
        }
        return $this;
    }
    /**
     * Add item to RadTaeidDataCnt value
     * @throws \InvalidArgumentException
     * @param \StructType\RadTaeidDataCnt $item
     * @return \ArrayType\ArrayOfRadTaeidDataCnt
     */
    public function addToRadTaeidDataCnt(\StructType\RadTaeidDataCnt $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RadTaeidDataCnt) {
            throw new \InvalidArgumentException(sprintf('The RadTaeidDataCnt property can only contain items of type \StructType\RadTaeidDataCnt, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RadTaeidDataCnt[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\RadTaeidDataCnt|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\RadTaeidDataCnt|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\RadTaeidDataCnt|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\RadTaeidDataCnt|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\RadTaeidDataCnt|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RadTaeidDataCnt
     */
    public function getAttributeName()
    {
        return 'RadTaeidDataCnt';
    }
}
