<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTradeDocInformationContainerCnt ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfTradeDocInformationContainerCnt
 * @subpackage Arrays
 */
class ArrayOfTradeDocInformationContainerCnt extends AbstractStructArrayBase
{
    /**
     * The TradeDocInformationContainerCnt
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TradeDocInformationContainerCnt[]
     */
    public $TradeDocInformationContainerCnt;
    /**
     * Constructor method for ArrayOfTradeDocInformationContainerCnt
     * @uses ArrayOfTradeDocInformationContainerCnt::setTradeDocInformationContainerCnt()
     * @param \StructType\TradeDocInformationContainerCnt[] $tradeDocInformationContainerCnt
     */
    public function __construct(array $tradeDocInformationContainerCnt = array())
    {
        $this
            ->setTradeDocInformationContainerCnt($tradeDocInformationContainerCnt);
    }
    /**
     * Get TradeDocInformationContainerCnt value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TradeDocInformationContainerCnt[]|null
     */
    public function getTradeDocInformationContainerCnt()
    {
        return isset($this->TradeDocInformationContainerCnt) ? $this->TradeDocInformationContainerCnt : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTradeDocInformationContainerCnt method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTradeDocInformationContainerCnt method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTradeDocInformationContainerCntForArrayConstraintsFromSetTradeDocInformationContainerCnt(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTradeDocInformationContainerCntTradeDocInformationContainerCntItem) {
            // validation for constraint: itemType
            if (!$arrayOfTradeDocInformationContainerCntTradeDocInformationContainerCntItem instanceof \StructType\TradeDocInformationContainerCnt) {
                $invalidValues[] = is_object($arrayOfTradeDocInformationContainerCntTradeDocInformationContainerCntItem) ? get_class($arrayOfTradeDocInformationContainerCntTradeDocInformationContainerCntItem) : sprintf('%s(%s)', gettype($arrayOfTradeDocInformationContainerCntTradeDocInformationContainerCntItem), var_export($arrayOfTradeDocInformationContainerCntTradeDocInformationContainerCntItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TradeDocInformationContainerCnt property can only contain items of type \StructType\TradeDocInformationContainerCnt, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TradeDocInformationContainerCnt value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TradeDocInformationContainerCnt[] $tradeDocInformationContainerCnt
     * @return \ArrayType\ArrayOfTradeDocInformationContainerCnt
     */
    public function setTradeDocInformationContainerCnt(array $tradeDocInformationContainerCnt = array())
    {
        // validation for constraint: array
        if ('' !== ($tradeDocInformationContainerCntArrayErrorMessage = self::validateTradeDocInformationContainerCntForArrayConstraintsFromSetTradeDocInformationContainerCnt($tradeDocInformationContainerCnt))) {
            throw new \InvalidArgumentException($tradeDocInformationContainerCntArrayErrorMessage, __LINE__);
        }
        if (is_null($tradeDocInformationContainerCnt) || (is_array($tradeDocInformationContainerCnt) && empty($tradeDocInformationContainerCnt))) {
            unset($this->TradeDocInformationContainerCnt);
        } else {
            $this->TradeDocInformationContainerCnt = $tradeDocInformationContainerCnt;
        }
        return $this;
    }
    /**
     * Add item to TradeDocInformationContainerCnt value
     * @throws \InvalidArgumentException
     * @param \StructType\TradeDocInformationContainerCnt $item
     * @return \ArrayType\ArrayOfTradeDocInformationContainerCnt
     */
    public function addToTradeDocInformationContainerCnt(\StructType\TradeDocInformationContainerCnt $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TradeDocInformationContainerCnt) {
            throw new \InvalidArgumentException(sprintf('The TradeDocInformationContainerCnt property can only contain items of type \StructType\TradeDocInformationContainerCnt, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TradeDocInformationContainerCnt[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TradeDocInformationContainerCnt|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TradeDocInformationContainerCnt|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TradeDocInformationContainerCnt|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TradeDocInformationContainerCnt|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TradeDocInformationContainerCnt|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TradeDocInformationContainerCnt
     */
    public function getAttributeName()
    {
        return 'TradeDocInformationContainerCnt';
    }
}
