<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'InsertBillOfLading' => '\\StructType\\InsertBillOfLading',
            'InsertBillOfLadingResponse' => '\\StructType\\InsertBillOfLadingResponse',
            'RegisterBillOfLadingFormAsDamaged' => '\\StructType\\RegisterBillOfLadingFormAsDamaged',
            'RegisterBillOfLadingFormAsDamagedResponse' => '\\StructType\\RegisterBillOfLadingFormAsDamagedResponse',
            'LoadBillOfLadingByNumber' => '\\StructType\\LoadBillOfLadingByNumber',
            'LoadBillOfLadingByNumberResponse' => '\\StructType\\LoadBillOfLadingByNumberResponse',
            'GetDriverBySmartCardNo' => '\\StructType\\GetDriverBySmartCardNo',
            'GetDriverBySmartCardNoResponse' => '\\StructType\\GetDriverBySmartCardNoResponse',
            'GetDriverByNational_ID' => '\\StructType\\GetDriverByNational_ID',
            'GetDriverByNational_IDResponse' => '\\StructType\\GetDriverByNational_IDResponse',
            'GetFreighterBySmartCardNo' => '\\StructType\\GetFreighterBySmartCardNo',
            'GetFreighterBySmartCardNoResponse' => '\\StructType\\GetFreighterBySmartCardNoResponse',
            'GetCompanyStatus' => '\\StructType\\GetCompanyStatus',
            'GetCompanyStatusResponse' => '\\StructType\\GetCompanyStatusResponse',
            'GetFreighterBySmartCardNoFull' => '\\StructType\\GetFreighterBySmartCardNoFull',
            'GetFreighterBySmartCardNoFullResponse' => '\\StructType\\GetFreighterBySmartCardNoFullResponse',
            'LoadAllBillOfLadingByNumber' => '\\StructType\\LoadAllBillOfLadingByNumber',
            'LoadAllBillOfLadingByNumberResponse' => '\\StructType\\LoadAllBillOfLadingByNumberResponse',
            'RegisterReceipt' => '\\StructType\\RegisterReceipt',
            'RegisterReceiptResponse' => '\\StructType\\RegisterReceiptResponse',
            'DeleteReceiptByID' => '\\StructType\\DeleteReceiptByID',
            'DeleteReceiptByIDResponse' => '\\StructType\\DeleteReceiptByIDResponse',
            'GetBillOfLadingByFreighterCardNumberInToday' => '\\StructType\\GetBillOfLadingByFreighterCardNumberInToday',
            'GetBillOfLadingByFreighterCardNumberInTodayResponse' => '\\StructType\\GetBillOfLadingByFreighterCardNumberInTodayResponse',
            'GetBillOfLadingByDriverCardNumberInToday' => '\\StructType\\GetBillOfLadingByDriverCardNumberInToday',
            'GetBillOfLadingByDriverCardNumberInTodayResponse' => '\\StructType\\GetBillOfLadingByDriverCardNumberInTodayResponse',
            'GetBillOfLadingByDriverNationalIdInToday' => '\\StructType\\GetBillOfLadingByDriverNationalIdInToday',
            'GetBillOfLadingByDriverNationalIdInTodayResponse' => '\\StructType\\GetBillOfLadingByDriverNationalIdInTodayResponse',
            'GetBillOfLadingByDriverNationalID' => '\\StructType\\GetBillOfLadingByDriverNationalID',
            'GetBillOfLadingByDriverNationalIDResponse' => '\\StructType\\GetBillOfLadingByDriverNationalIDResponse',
            'GetBillOfLadingByPlaque' => '\\StructType\\GetBillOfLadingByPlaque',
            'GetBillOfLadingByPlaqueResponse' => '\\StructType\\GetBillOfLadingByPlaqueResponse',
            'CheckExistBillOfLadingBySerialAndNumber' => '\\StructType\\CheckExistBillOfLadingBySerialAndNumber',
            'CheckExistBillOfLadingBySerialAndNumberResponse' => '\\StructType\\CheckExistBillOfLadingBySerialAndNumberResponse',
            'GetRmtoCurrentDate' => '\\StructType\\GetRmtoCurrentDate',
            'GetRmtoCurrentDateResponse' => '\\StructType\\GetRmtoCurrentDateResponse',
            'Inquiry_LegalPerson' => '\\StructType\\Inquiry_LegalPerson',
            'Inquiry_LegalPersonResponse' => '\\StructType\\Inquiry_LegalPersonResponse',
            'Inquiry_RealPerson' => '\\StructType\\Inquiry_RealPerson',
            'Inquiry_RealPersonResponse' => '\\StructType\\Inquiry_RealPersonResponse',
            'Inquiry_PostalCode' => '\\StructType\\Inquiry_PostalCode',
            'Inquiry_PostalCodeResponse' => '\\StructType\\Inquiry_PostalCodeResponse',
            'Inquiry_Insurance' => '\\StructType\\Inquiry_Insurance',
            'Inquiry_InsuranceResponse' => '\\StructType\\Inquiry_InsuranceResponse',
            'Inquiry_RadTaeid_Barnameh' => '\\StructType\\Inquiry_RadTaeid_Barnameh',
            'Inquiry_RadTaeid_BarnamehResponse' => '\\StructType\\Inquiry_RadTaeid_BarnamehResponse',
            'Inquiry_TradeDocInformation' => '\\StructType\\Inquiry_TradeDocInformation',
            'Inquiry_TradeDocInformationResponse' => '\\StructType\\Inquiry_TradeDocInformationResponse',
            'Inquiry_CheckWaybillAssign' => '\\StructType\\Inquiry_CheckWaybillAssign',
            'Inquiry_CheckWaybillAssignResponse' => '\\StructType\\Inquiry_CheckWaybillAssignResponse',
            'BillOfLading' => '\\StructType\\BillOfLading',
            'Custom' => '\\StructType\\Custom',
            'ArrayOfGoodInfo' => '\\ArrayType\\ArrayOfGoodInfo',
            'GoodInfo' => '\\StructType\\GoodInfo',
            'ArrayOfTradeDocInformationContainerCnt' => '\\ArrayType\\ArrayOfTradeDocInformationContainerCnt',
            'TradeDocInformationContainerCnt' => '\\StructType\\TradeDocInformationContainerCnt',
            'ArrayOfTradeDocInformationGoodsCnt' => '\\ArrayType\\ArrayOfTradeDocInformationGoodsCnt',
            'TradeDocInformationGoodsCnt' => '\\StructType\\TradeDocInformationGoodsCnt',
            'ArrayOfTradeDocInformationSealsCnt' => '\\ArrayType\\ArrayOfTradeDocInformationSealsCnt',
            'TradeDocInformationSealsCnt' => '\\StructType\\TradeDocInformationSealsCnt',
            'PersianDate' => '\\StructType\\PersianDate',
            'ArrayOfBillOfLadingKhordehBar' => '\\ArrayType\\ArrayOfBillOfLadingKhordehBar',
            'BillOfLadingKhordehBar' => '\\StructType\\BillOfLadingKhordehBar',
            'Person' => '\\StructType\\Person',
            'RealPerson' => '\\StructType\\RealPerson',
            'LegalPerson' => '\\StructType\\LegalPerson',
            'DriverInfo' => '\\StructType\\DriverInfo',
            'FreighterInfo' => '\\StructType\\FreighterInfo',
            'ArrayOfGoodFullInfo' => '\\ArrayType\\ArrayOfGoodFullInfo',
            'GoodFullInfo' => '\\StructType\\GoodFullInfo',
            'BillOfLadingFullInfo' => '\\StructType\\BillOfLadingFullInfo',
            'Company' => '\\StructType\\Company',
            'CompanyBranch' => '\\StructType\\CompanyBranch',
            'FreighterInfoFull' => '\\StructType\\FreighterInfoFull',
            'ArrayOfBillOfLadingFullInfo' => '\\ArrayType\\ArrayOfBillOfLadingFullInfo',
            'Receipt' => '\\StructType\\Receipt',
            'ArrayOfBillOfLadingInfo' => '\\ArrayType\\ArrayOfBillOfLadingInfo',
            'BillOfLadingInfo' => '\\StructType\\BillOfLadingInfo',
            'RadTaeidCnt' => '\\StructType\\RadTaeidCnt',
            'ArrayOfRadTaeidDataCnt' => '\\ArrayType\\ArrayOfRadTaeidDataCnt',
            'RadTaeidDataCnt' => '\\StructType\\RadTaeidDataCnt',
            'ArrayOfRadTaeidGoodCnt' => '\\ArrayType\\ArrayOfRadTaeidGoodCnt',
            'RadTaeidGoodCnt' => '\\StructType\\RadTaeidGoodCnt',
            'TradeDocInformationCnt' => '\\StructType\\TradeDocInformationCnt',
            'CheckWaybillAssignCnt' => '\\StructType\\CheckWaybillAssignCnt',
            'ArrayOfCheckWaybillAssignGoodsCnt' => '\\ArrayType\\ArrayOfCheckWaybillAssignGoodsCnt',
            'CheckWaybillAssignGoodsCnt' => '\\StructType\\CheckWaybillAssignGoodsCnt',
            'InquiryResponse' => '\\StructType\\InquiryResponse',
            'PersonInfo' => '\\StructType\\PersonInfo',
            'ResponseItem' => '\\StructType\\ResponseItem',
            'InquiryResultCnt' => '\\StructType\\InquiryResultCnt',
            'InquiryInsuranceResultCnt' => '\\StructType\\InquiryInsuranceResultCnt',
            'ArrayOfInquiryInsuranceEndorsmentResultCnt' => '\\ArrayType\\ArrayOfInquiryInsuranceEndorsmentResultCnt',
            'InquiryInsuranceEndorsmentResultCnt' => '\\StructType\\InquiryInsuranceEndorsmentResultCnt',
            'AccessControlFault' => '\\StructType\\AccessControlFault',
            'ValidationFault' => '\\StructType\\ValidationFault',
            'ArrayOfValidaitonFaultItem' => '\\ArrayType\\ArrayOfValidaitonFaultItem',
            'ValidaitonFaultItem' => '\\StructType\\ValidaitonFaultItem',
            'ServiceInternalFault' => '\\StructType\\ServiceInternalFault',
            'PersonInquiryFault' => '\\StructType\\PersonInquiryFault',
            'ArrayOfanyType' => '\\ArrayType\\ArrayOfanyType',
        );
    }
}
