<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CheckWaybillAssignCnt StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:CheckWaybillAssignCnt
 * @subpackage Structs
 */
class CheckWaybillAssignCnt extends AbstractStructBase
{
    /**
     * The CarrierCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CarrierCode;
    /**
     * The CreatedOn
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $CreatedOn;
    /**
     * The DestinationCityCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $DestinationCityCode;
    /**
     * The DriverNationalId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $DriverNationalId;
    /**
     * The EndDate
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $EndDate;
    /**
     * The FleetCardNo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $FleetCardNo;
    /**
     * The FleetPlaque
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $FleetPlaque;
    /**
     * The Goods
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfCheckWaybillAssignGoodsCnt
     */
    public $Goods;
    /**
     * The LoaderTypeCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $LoaderTypeCode;
    /**
     * The LoadingDate
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $LoadingDate;
    /**
     * The OriginCityCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $OriginCityCode;
    /**
     * The SecondDriverNationalId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $SecondDriverNationalId;
    /**
     * The StartDate
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $StartDate;
    /**
     * The TrCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $TrCode;
    /**
     * The UpdatedOn
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $UpdatedOn;
    /**
     * The Weight
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $Weight;
    /**
     * Constructor method for CheckWaybillAssignCnt
     * @uses CheckWaybillAssignCnt::setCarrierCode()
     * @uses CheckWaybillAssignCnt::setCreatedOn()
     * @uses CheckWaybillAssignCnt::setDestinationCityCode()
     * @uses CheckWaybillAssignCnt::setDriverNationalId()
     * @uses CheckWaybillAssignCnt::setEndDate()
     * @uses CheckWaybillAssignCnt::setFleetCardNo()
     * @uses CheckWaybillAssignCnt::setFleetPlaque()
     * @uses CheckWaybillAssignCnt::setGoods()
     * @uses CheckWaybillAssignCnt::setLoaderTypeCode()
     * @uses CheckWaybillAssignCnt::setLoadingDate()
     * @uses CheckWaybillAssignCnt::setOriginCityCode()
     * @uses CheckWaybillAssignCnt::setSecondDriverNationalId()
     * @uses CheckWaybillAssignCnt::setStartDate()
     * @uses CheckWaybillAssignCnt::setTrCode()
     * @uses CheckWaybillAssignCnt::setUpdatedOn()
     * @uses CheckWaybillAssignCnt::setWeight()
     * @param string $carrierCode
     * @param string $createdOn
     * @param string $destinationCityCode
     * @param string $driverNationalId
     * @param string $endDate
     * @param string $fleetCardNo
     * @param string $fleetPlaque
     * @param \ArrayType\ArrayOfCheckWaybillAssignGoodsCnt $goods
     * @param string $loaderTypeCode
     * @param string $loadingDate
     * @param string $originCityCode
     * @param string $secondDriverNationalId
     * @param string $startDate
     * @param int $trCode
     * @param string $updatedOn
     * @param int $weight
     */
    public function __construct($carrierCode = null, $createdOn = null, $destinationCityCode = null, $driverNationalId = null, $endDate = null, $fleetCardNo = null, $fleetPlaque = null, \ArrayType\ArrayOfCheckWaybillAssignGoodsCnt $goods = null, $loaderTypeCode = null, $loadingDate = null, $originCityCode = null, $secondDriverNationalId = null, $startDate = null, $trCode = null, $updatedOn = null, $weight = null)
    {
        $this
            ->setCarrierCode($carrierCode)
            ->setCreatedOn($createdOn)
            ->setDestinationCityCode($destinationCityCode)
            ->setDriverNationalId($driverNationalId)
            ->setEndDate($endDate)
            ->setFleetCardNo($fleetCardNo)
            ->setFleetPlaque($fleetPlaque)
            ->setGoods($goods)
            ->setLoaderTypeCode($loaderTypeCode)
            ->setLoadingDate($loadingDate)
            ->setOriginCityCode($originCityCode)
            ->setSecondDriverNationalId($secondDriverNationalId)
            ->setStartDate($startDate)
            ->setTrCode($trCode)
            ->setUpdatedOn($updatedOn)
            ->setWeight($weight);
    }
    /**
     * Get CarrierCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCarrierCode()
    {
        return isset($this->CarrierCode) ? $this->CarrierCode : null;
    }
    /**
     * Set CarrierCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $carrierCode
     * @return \StructType\CheckWaybillAssignCnt
     */
    public function setCarrierCode($carrierCode = null)
    {
        // validation for constraint: string
        if (!is_null($carrierCode) && !is_string($carrierCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($carrierCode, true), gettype($carrierCode)), __LINE__);
        }
        if (is_null($carrierCode) || (is_array($carrierCode) && empty($carrierCode))) {
            unset($this->CarrierCode);
        } else {
            $this->CarrierCode = $carrierCode;
        }
        return $this;
    }
    /**
     * Get CreatedOn value
     * @return string|null
     */
    public function getCreatedOn()
    {
        return $this->CreatedOn;
    }
    /**
     * Set CreatedOn value
     * @param string $createdOn
     * @return \StructType\CheckWaybillAssignCnt
     */
    public function setCreatedOn($createdOn = null)
    {
        // validation for constraint: string
        if (!is_null($createdOn) && !is_string($createdOn)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($createdOn, true), gettype($createdOn)), __LINE__);
        }
        $this->CreatedOn = $createdOn;
        return $this;
    }
    /**
     * Get DestinationCityCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDestinationCityCode()
    {
        return isset($this->DestinationCityCode) ? $this->DestinationCityCode : null;
    }
    /**
     * Set DestinationCityCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $destinationCityCode
     * @return \StructType\CheckWaybillAssignCnt
     */
    public function setDestinationCityCode($destinationCityCode = null)
    {
        // validation for constraint: string
        if (!is_null($destinationCityCode) && !is_string($destinationCityCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($destinationCityCode, true), gettype($destinationCityCode)), __LINE__);
        }
        if (is_null($destinationCityCode) || (is_array($destinationCityCode) && empty($destinationCityCode))) {
            unset($this->DestinationCityCode);
        } else {
            $this->DestinationCityCode = $destinationCityCode;
        }
        return $this;
    }
    /**
     * Get DriverNationalId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDriverNationalId()
    {
        return isset($this->DriverNationalId) ? $this->DriverNationalId : null;
    }
    /**
     * Set DriverNationalId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $driverNationalId
     * @return \StructType\CheckWaybillAssignCnt
     */
    public function setDriverNationalId($driverNationalId = null)
    {
        // validation for constraint: string
        if (!is_null($driverNationalId) && !is_string($driverNationalId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($driverNationalId, true), gettype($driverNationalId)), __LINE__);
        }
        if (is_null($driverNationalId) || (is_array($driverNationalId) && empty($driverNationalId))) {
            unset($this->DriverNationalId);
        } else {
            $this->DriverNationalId = $driverNationalId;
        }
        return $this;
    }
    /**
     * Get EndDate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getEndDate()
    {
        return isset($this->EndDate) ? $this->EndDate : null;
    }
    /**
     * Set EndDate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $endDate
     * @return \StructType\CheckWaybillAssignCnt
     */
    public function setEndDate($endDate = null)
    {
        // validation for constraint: string
        if (!is_null($endDate) && !is_string($endDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($endDate, true), gettype($endDate)), __LINE__);
        }
        if (is_null($endDate) || (is_array($endDate) && empty($endDate))) {
            unset($this->EndDate);
        } else {
            $this->EndDate = $endDate;
        }
        return $this;
    }
    /**
     * Get FleetCardNo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFleetCardNo()
    {
        return isset($this->FleetCardNo) ? $this->FleetCardNo : null;
    }
    /**
     * Set FleetCardNo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $fleetCardNo
     * @return \StructType\CheckWaybillAssignCnt
     */
    public function setFleetCardNo($fleetCardNo = null)
    {
        // validation for constraint: string
        if (!is_null($fleetCardNo) && !is_string($fleetCardNo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fleetCardNo, true), gettype($fleetCardNo)), __LINE__);
        }
        if (is_null($fleetCardNo) || (is_array($fleetCardNo) && empty($fleetCardNo))) {
            unset($this->FleetCardNo);
        } else {
            $this->FleetCardNo = $fleetCardNo;
        }
        return $this;
    }
    /**
     * Get FleetPlaque value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFleetPlaque()
    {
        return isset($this->FleetPlaque) ? $this->FleetPlaque : null;
    }
    /**
     * Set FleetPlaque value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $fleetPlaque
     * @return \StructType\CheckWaybillAssignCnt
     */
    public function setFleetPlaque($fleetPlaque = null)
    {
        // validation for constraint: string
        if (!is_null($fleetPlaque) && !is_string($fleetPlaque)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fleetPlaque, true), gettype($fleetPlaque)), __LINE__);
        }
        if (is_null($fleetPlaque) || (is_array($fleetPlaque) && empty($fleetPlaque))) {
            unset($this->FleetPlaque);
        } else {
            $this->FleetPlaque = $fleetPlaque;
        }
        return $this;
    }
    /**
     * Get Goods value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfCheckWaybillAssignGoodsCnt|null
     */
    public function getGoods()
    {
        return isset($this->Goods) ? $this->Goods : null;
    }
    /**
     * Set Goods value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfCheckWaybillAssignGoodsCnt $goods
     * @return \StructType\CheckWaybillAssignCnt
     */
    public function setGoods(\ArrayType\ArrayOfCheckWaybillAssignGoodsCnt $goods = null)
    {
        if (is_null($goods) || (is_array($goods) && empty($goods))) {
            unset($this->Goods);
        } else {
            $this->Goods = $goods;
        }
        return $this;
    }
    /**
     * Get LoaderTypeCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLoaderTypeCode()
    {
        return isset($this->LoaderTypeCode) ? $this->LoaderTypeCode : null;
    }
    /**
     * Set LoaderTypeCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $loaderTypeCode
     * @return \StructType\CheckWaybillAssignCnt
     */
    public function setLoaderTypeCode($loaderTypeCode = null)
    {
        // validation for constraint: string
        if (!is_null($loaderTypeCode) && !is_string($loaderTypeCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($loaderTypeCode, true), gettype($loaderTypeCode)), __LINE__);
        }
        if (is_null($loaderTypeCode) || (is_array($loaderTypeCode) && empty($loaderTypeCode))) {
            unset($this->LoaderTypeCode);
        } else {
            $this->LoaderTypeCode = $loaderTypeCode;
        }
        return $this;
    }
    /**
     * Get LoadingDate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLoadingDate()
    {
        return isset($this->LoadingDate) ? $this->LoadingDate : null;
    }
    /**
     * Set LoadingDate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $loadingDate
     * @return \StructType\CheckWaybillAssignCnt
     */
    public function setLoadingDate($loadingDate = null)
    {
        // validation for constraint: string
        if (!is_null($loadingDate) && !is_string($loadingDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($loadingDate, true), gettype($loadingDate)), __LINE__);
        }
        if (is_null($loadingDate) || (is_array($loadingDate) && empty($loadingDate))) {
            unset($this->LoadingDate);
        } else {
            $this->LoadingDate = $loadingDate;
        }
        return $this;
    }
    /**
     * Get OriginCityCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getOriginCityCode()
    {
        return isset($this->OriginCityCode) ? $this->OriginCityCode : null;
    }
    /**
     * Set OriginCityCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $originCityCode
     * @return \StructType\CheckWaybillAssignCnt
     */
    public function setOriginCityCode($originCityCode = null)
    {
        // validation for constraint: string
        if (!is_null($originCityCode) && !is_string($originCityCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($originCityCode, true), gettype($originCityCode)), __LINE__);
        }
        if (is_null($originCityCode) || (is_array($originCityCode) && empty($originCityCode))) {
            unset($this->OriginCityCode);
        } else {
            $this->OriginCityCode = $originCityCode;
        }
        return $this;
    }
    /**
     * Get SecondDriverNationalId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSecondDriverNationalId()
    {
        return isset($this->SecondDriverNationalId) ? $this->SecondDriverNationalId : null;
    }
    /**
     * Set SecondDriverNationalId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $secondDriverNationalId
     * @return \StructType\CheckWaybillAssignCnt
     */
    public function setSecondDriverNationalId($secondDriverNationalId = null)
    {
        // validation for constraint: string
        if (!is_null($secondDriverNationalId) && !is_string($secondDriverNationalId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($secondDriverNationalId, true), gettype($secondDriverNationalId)), __LINE__);
        }
        if (is_null($secondDriverNationalId) || (is_array($secondDriverNationalId) && empty($secondDriverNationalId))) {
            unset($this->SecondDriverNationalId);
        } else {
            $this->SecondDriverNationalId = $secondDriverNationalId;
        }
        return $this;
    }
    /**
     * Get StartDate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getStartDate()
    {
        return isset($this->StartDate) ? $this->StartDate : null;
    }
    /**
     * Set StartDate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $startDate
     * @return \StructType\CheckWaybillAssignCnt
     */
    public function setStartDate($startDate = null)
    {
        // validation for constraint: string
        if (!is_null($startDate) && !is_string($startDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($startDate, true), gettype($startDate)), __LINE__);
        }
        if (is_null($startDate) || (is_array($startDate) && empty($startDate))) {
            unset($this->StartDate);
        } else {
            $this->StartDate = $startDate;
        }
        return $this;
    }
    /**
     * Get TrCode value
     * @return int|null
     */
    public function getTrCode()
    {
        return $this->TrCode;
    }
    /**
     * Set TrCode value
     * @param int $trCode
     * @return \StructType\CheckWaybillAssignCnt
     */
    public function setTrCode($trCode = null)
    {
        // validation for constraint: int
        if (!is_null($trCode) && !(is_int($trCode) || ctype_digit($trCode))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($trCode, true), gettype($trCode)), __LINE__);
        }
        $this->TrCode = $trCode;
        return $this;
    }
    /**
     * Get UpdatedOn value
     * @return string|null
     */
    public function getUpdatedOn()
    {
        return $this->UpdatedOn;
    }
    /**
     * Set UpdatedOn value
     * @param string $updatedOn
     * @return \StructType\CheckWaybillAssignCnt
     */
    public function setUpdatedOn($updatedOn = null)
    {
        // validation for constraint: string
        if (!is_null($updatedOn) && !is_string($updatedOn)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($updatedOn, true), gettype($updatedOn)), __LINE__);
        }
        $this->UpdatedOn = $updatedOn;
        return $this;
    }
    /**
     * Get Weight value
     * @return int|null
     */
    public function getWeight()
    {
        return $this->Weight;
    }
    /**
     * Set Weight value
     * @param int $weight
     * @return \StructType\CheckWaybillAssignCnt
     */
    public function setWeight($weight = null)
    {
        // validation for constraint: int
        if (!is_null($weight) && !(is_int($weight) || ctype_digit($weight))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($weight, true), gettype($weight)), __LINE__);
        }
        $this->Weight = $weight;
        return $this;
    }
}
