<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DriverInfo StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:DriverInfo
 * @subpackage Structs
 */
class DriverInfo extends AbstractStructBase
{
    /**
     * The BirthCityCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $BirthCityCode;
    /**
     * The BirthCityName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $BirthCityName;
    /**
     * The CardNumber
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CardNumber;
    /**
     * The CardValidationDate
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PersianDate
     */
    public $CardValidationDate;
    /**
     * The CertifcateIssueCityCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $CertifcateIssueCityCode;
    /**
     * The CertifcateIssueCityName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CertifcateIssueCityName;
    /**
     * The CertifcateNumber
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CertifcateNumber;
    /**
     * The Driver_Type
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Driver_Type;
    /**
     * The Family
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Family;
    /**
     * The FatherName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $FatherName;
    /**
     * The IdentifierNumber
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $IdentifierNumber;
    /**
     * The InsuranceBranch
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $InsuranceBranch;
    /**
     * The InsuranceId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $InsuranceId;
    /**
     * The IsActive
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $IsActive;
    /**
     * The Mobile
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Mobile;
    /**
     * The NOVE_GAVAHINAMEH
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $NOVE_GAVAHINAMEH;
    /**
     * The Name
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Name;
    /**
     * The NationalId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $NationalId;
    /**
     * The TARIKH_ETEBAR_KART_SALAMAT
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $TARIKH_ETEBAR_KART_SALAMAT;
    /**
     * Constructor method for DriverInfo
     * @uses DriverInfo::setBirthCityCode()
     * @uses DriverInfo::setBirthCityName()
     * @uses DriverInfo::setCardNumber()
     * @uses DriverInfo::setCardValidationDate()
     * @uses DriverInfo::setCertifcateIssueCityCode()
     * @uses DriverInfo::setCertifcateIssueCityName()
     * @uses DriverInfo::setCertifcateNumber()
     * @uses DriverInfo::setDriver_Type()
     * @uses DriverInfo::setFamily()
     * @uses DriverInfo::setFatherName()
     * @uses DriverInfo::setIdentifierNumber()
     * @uses DriverInfo::setInsuranceBranch()
     * @uses DriverInfo::setInsuranceId()
     * @uses DriverInfo::setIsActive()
     * @uses DriverInfo::setMobile()
     * @uses DriverInfo::setNOVE_GAVAHINAMEH()
     * @uses DriverInfo::setName()
     * @uses DriverInfo::setNationalId()
     * @uses DriverInfo::setTARIKH_ETEBAR_KART_SALAMAT()
     * @param int $birthCityCode
     * @param string $birthCityName
     * @param string $cardNumber
     * @param \StructType\PersianDate $cardValidationDate
     * @param int $certifcateIssueCityCode
     * @param string $certifcateIssueCityName
     * @param string $certifcateNumber
     * @param string $driver_Type
     * @param string $family
     * @param string $fatherName
     * @param string $identifierNumber
     * @param string $insuranceBranch
     * @param string $insuranceId
     * @param bool $isActive
     * @param string $mobile
     * @param string $nOVE_GAVAHINAMEH
     * @param string $name
     * @param string $nationalId
     * @param string $tARIKH_ETEBAR_KART_SALAMAT
     */
    public function __construct($birthCityCode = null, $birthCityName = null, $cardNumber = null, \StructType\PersianDate $cardValidationDate = null, $certifcateIssueCityCode = null, $certifcateIssueCityName = null, $certifcateNumber = null, $driver_Type = null, $family = null, $fatherName = null, $identifierNumber = null, $insuranceBranch = null, $insuranceId = null, $isActive = null, $mobile = null, $nOVE_GAVAHINAMEH = null, $name = null, $nationalId = null, $tARIKH_ETEBAR_KART_SALAMAT = null)
    {
        $this
            ->setBirthCityCode($birthCityCode)
            ->setBirthCityName($birthCityName)
            ->setCardNumber($cardNumber)
            ->setCardValidationDate($cardValidationDate)
            ->setCertifcateIssueCityCode($certifcateIssueCityCode)
            ->setCertifcateIssueCityName($certifcateIssueCityName)
            ->setCertifcateNumber($certifcateNumber)
            ->setDriver_Type($driver_Type)
            ->setFamily($family)
            ->setFatherName($fatherName)
            ->setIdentifierNumber($identifierNumber)
            ->setInsuranceBranch($insuranceBranch)
            ->setInsuranceId($insuranceId)
            ->setIsActive($isActive)
            ->setMobile($mobile)
            ->setNOVE_GAVAHINAMEH($nOVE_GAVAHINAMEH)
            ->setName($name)
            ->setNationalId($nationalId)
            ->setTARIKH_ETEBAR_KART_SALAMAT($tARIKH_ETEBAR_KART_SALAMAT);
    }
    /**
     * Get BirthCityCode value
     * @return int|null
     */
    public function getBirthCityCode()
    {
        return $this->BirthCityCode;
    }
    /**
     * Set BirthCityCode value
     * @param int $birthCityCode
     * @return \StructType\DriverInfo
     */
    public function setBirthCityCode($birthCityCode = null)
    {
        // validation for constraint: int
        if (!is_null($birthCityCode) && !(is_int($birthCityCode) || ctype_digit($birthCityCode))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($birthCityCode, true), gettype($birthCityCode)), __LINE__);
        }
        $this->BirthCityCode = $birthCityCode;
        return $this;
    }
    /**
     * Get BirthCityName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getBirthCityName()
    {
        return isset($this->BirthCityName) ? $this->BirthCityName : null;
    }
    /**
     * Set BirthCityName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $birthCityName
     * @return \StructType\DriverInfo
     */
    public function setBirthCityName($birthCityName = null)
    {
        // validation for constraint: string
        if (!is_null($birthCityName) && !is_string($birthCityName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($birthCityName, true), gettype($birthCityName)), __LINE__);
        }
        if (is_null($birthCityName) || (is_array($birthCityName) && empty($birthCityName))) {
            unset($this->BirthCityName);
        } else {
            $this->BirthCityName = $birthCityName;
        }
        return $this;
    }
    /**
     * Get CardNumber value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCardNumber()
    {
        return isset($this->CardNumber) ? $this->CardNumber : null;
    }
    /**
     * Set CardNumber value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $cardNumber
     * @return \StructType\DriverInfo
     */
    public function setCardNumber($cardNumber = null)
    {
        // validation for constraint: string
        if (!is_null($cardNumber) && !is_string($cardNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cardNumber, true), gettype($cardNumber)), __LINE__);
        }
        if (is_null($cardNumber) || (is_array($cardNumber) && empty($cardNumber))) {
            unset($this->CardNumber);
        } else {
            $this->CardNumber = $cardNumber;
        }
        return $this;
    }
    /**
     * Get CardValidationDate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PersianDate|null
     */
    public function getCardValidationDate()
    {
        return isset($this->CardValidationDate) ? $this->CardValidationDate : null;
    }
    /**
     * Set CardValidationDate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\PersianDate $cardValidationDate
     * @return \StructType\DriverInfo
     */
    public function setCardValidationDate(\StructType\PersianDate $cardValidationDate = null)
    {
        if (is_null($cardValidationDate) || (is_array($cardValidationDate) && empty($cardValidationDate))) {
            unset($this->CardValidationDate);
        } else {
            $this->CardValidationDate = $cardValidationDate;
        }
        return $this;
    }
    /**
     * Get CertifcateIssueCityCode value
     * @return int|null
     */
    public function getCertifcateIssueCityCode()
    {
        return $this->CertifcateIssueCityCode;
    }
    /**
     * Set CertifcateIssueCityCode value
     * @param int $certifcateIssueCityCode
     * @return \StructType\DriverInfo
     */
    public function setCertifcateIssueCityCode($certifcateIssueCityCode = null)
    {
        // validation for constraint: int
        if (!is_null($certifcateIssueCityCode) && !(is_int($certifcateIssueCityCode) || ctype_digit($certifcateIssueCityCode))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($certifcateIssueCityCode, true), gettype($certifcateIssueCityCode)), __LINE__);
        }
        $this->CertifcateIssueCityCode = $certifcateIssueCityCode;
        return $this;
    }
    /**
     * Get CertifcateIssueCityName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCertifcateIssueCityName()
    {
        return isset($this->CertifcateIssueCityName) ? $this->CertifcateIssueCityName : null;
    }
    /**
     * Set CertifcateIssueCityName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $certifcateIssueCityName
     * @return \StructType\DriverInfo
     */
    public function setCertifcateIssueCityName($certifcateIssueCityName = null)
    {
        // validation for constraint: string
        if (!is_null($certifcateIssueCityName) && !is_string($certifcateIssueCityName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($certifcateIssueCityName, true), gettype($certifcateIssueCityName)), __LINE__);
        }
        if (is_null($certifcateIssueCityName) || (is_array($certifcateIssueCityName) && empty($certifcateIssueCityName))) {
            unset($this->CertifcateIssueCityName);
        } else {
            $this->CertifcateIssueCityName = $certifcateIssueCityName;
        }
        return $this;
    }
    /**
     * Get CertifcateNumber value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCertifcateNumber()
    {
        return isset($this->CertifcateNumber) ? $this->CertifcateNumber : null;
    }
    /**
     * Set CertifcateNumber value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $certifcateNumber
     * @return \StructType\DriverInfo
     */
    public function setCertifcateNumber($certifcateNumber = null)
    {
        // validation for constraint: string
        if (!is_null($certifcateNumber) && !is_string($certifcateNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($certifcateNumber, true), gettype($certifcateNumber)), __LINE__);
        }
        if (is_null($certifcateNumber) || (is_array($certifcateNumber) && empty($certifcateNumber))) {
            unset($this->CertifcateNumber);
        } else {
            $this->CertifcateNumber = $certifcateNumber;
        }
        return $this;
    }
    /**
     * Get Driver_Type value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDriver_Type()
    {
        return isset($this->Driver_Type) ? $this->Driver_Type : null;
    }
    /**
     * Set Driver_Type value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $driver_Type
     * @return \StructType\DriverInfo
     */
    public function setDriver_Type($driver_Type = null)
    {
        // validation for constraint: string
        if (!is_null($driver_Type) && !is_string($driver_Type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($driver_Type, true), gettype($driver_Type)), __LINE__);
        }
        if (is_null($driver_Type) || (is_array($driver_Type) && empty($driver_Type))) {
            unset($this->Driver_Type);
        } else {
            $this->Driver_Type = $driver_Type;
        }
        return $this;
    }
    /**
     * Get Family value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFamily()
    {
        return isset($this->Family) ? $this->Family : null;
    }
    /**
     * Set Family value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $family
     * @return \StructType\DriverInfo
     */
    public function setFamily($family = null)
    {
        // validation for constraint: string
        if (!is_null($family) && !is_string($family)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($family, true), gettype($family)), __LINE__);
        }
        if (is_null($family) || (is_array($family) && empty($family))) {
            unset($this->Family);
        } else {
            $this->Family = $family;
        }
        return $this;
    }
    /**
     * Get FatherName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFatherName()
    {
        return isset($this->FatherName) ? $this->FatherName : null;
    }
    /**
     * Set FatherName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $fatherName
     * @return \StructType\DriverInfo
     */
    public function setFatherName($fatherName = null)
    {
        // validation for constraint: string
        if (!is_null($fatherName) && !is_string($fatherName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fatherName, true), gettype($fatherName)), __LINE__);
        }
        if (is_null($fatherName) || (is_array($fatherName) && empty($fatherName))) {
            unset($this->FatherName);
        } else {
            $this->FatherName = $fatherName;
        }
        return $this;
    }
    /**
     * Get IdentifierNumber value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getIdentifierNumber()
    {
        return isset($this->IdentifierNumber) ? $this->IdentifierNumber : null;
    }
    /**
     * Set IdentifierNumber value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $identifierNumber
     * @return \StructType\DriverInfo
     */
    public function setIdentifierNumber($identifierNumber = null)
    {
        // validation for constraint: string
        if (!is_null($identifierNumber) && !is_string($identifierNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($identifierNumber, true), gettype($identifierNumber)), __LINE__);
        }
        if (is_null($identifierNumber) || (is_array($identifierNumber) && empty($identifierNumber))) {
            unset($this->IdentifierNumber);
        } else {
            $this->IdentifierNumber = $identifierNumber;
        }
        return $this;
    }
    /**
     * Get InsuranceBranch value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getInsuranceBranch()
    {
        return isset($this->InsuranceBranch) ? $this->InsuranceBranch : null;
    }
    /**
     * Set InsuranceBranch value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $insuranceBranch
     * @return \StructType\DriverInfo
     */
    public function setInsuranceBranch($insuranceBranch = null)
    {
        // validation for constraint: string
        if (!is_null($insuranceBranch) && !is_string($insuranceBranch)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($insuranceBranch, true), gettype($insuranceBranch)), __LINE__);
        }
        if (is_null($insuranceBranch) || (is_array($insuranceBranch) && empty($insuranceBranch))) {
            unset($this->InsuranceBranch);
        } else {
            $this->InsuranceBranch = $insuranceBranch;
        }
        return $this;
    }
    /**
     * Get InsuranceId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getInsuranceId()
    {
        return isset($this->InsuranceId) ? $this->InsuranceId : null;
    }
    /**
     * Set InsuranceId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $insuranceId
     * @return \StructType\DriverInfo
     */
    public function setInsuranceId($insuranceId = null)
    {
        // validation for constraint: string
        if (!is_null($insuranceId) && !is_string($insuranceId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($insuranceId, true), gettype($insuranceId)), __LINE__);
        }
        if (is_null($insuranceId) || (is_array($insuranceId) && empty($insuranceId))) {
            unset($this->InsuranceId);
        } else {
            $this->InsuranceId = $insuranceId;
        }
        return $this;
    }
    /**
     * Get IsActive value
     * @return bool|null
     */
    public function getIsActive()
    {
        return $this->IsActive;
    }
    /**
     * Set IsActive value
     * @param bool $isActive
     * @return \StructType\DriverInfo
     */
    public function setIsActive($isActive = null)
    {
        // validation for constraint: boolean
        if (!is_null($isActive) && !is_bool($isActive)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isActive, true), gettype($isActive)), __LINE__);
        }
        $this->IsActive = $isActive;
        return $this;
    }
    /**
     * Get Mobile value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMobile()
    {
        return isset($this->Mobile) ? $this->Mobile : null;
    }
    /**
     * Set Mobile value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $mobile
     * @return \StructType\DriverInfo
     */
    public function setMobile($mobile = null)
    {
        // validation for constraint: string
        if (!is_null($mobile) && !is_string($mobile)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($mobile, true), gettype($mobile)), __LINE__);
        }
        if (is_null($mobile) || (is_array($mobile) && empty($mobile))) {
            unset($this->Mobile);
        } else {
            $this->Mobile = $mobile;
        }
        return $this;
    }
    /**
     * Get NOVE_GAVAHINAMEH value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNOVE_GAVAHINAMEH()
    {
        return isset($this->NOVE_GAVAHINAMEH) ? $this->NOVE_GAVAHINAMEH : null;
    }
    /**
     * Set NOVE_GAVAHINAMEH value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $nOVE_GAVAHINAMEH
     * @return \StructType\DriverInfo
     */
    public function setNOVE_GAVAHINAMEH($nOVE_GAVAHINAMEH = null)
    {
        // validation for constraint: string
        if (!is_null($nOVE_GAVAHINAMEH) && !is_string($nOVE_GAVAHINAMEH)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($nOVE_GAVAHINAMEH, true), gettype($nOVE_GAVAHINAMEH)), __LINE__);
        }
        if (is_null($nOVE_GAVAHINAMEH) || (is_array($nOVE_GAVAHINAMEH) && empty($nOVE_GAVAHINAMEH))) {
            unset($this->NOVE_GAVAHINAMEH);
        } else {
            $this->NOVE_GAVAHINAMEH = $nOVE_GAVAHINAMEH;
        }
        return $this;
    }
    /**
     * Get Name value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getName()
    {
        return isset($this->Name) ? $this->Name : null;
    }
    /**
     * Set Name value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $name
     * @return \StructType\DriverInfo
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        if (is_null($name) || (is_array($name) && empty($name))) {
            unset($this->Name);
        } else {
            $this->Name = $name;
        }
        return $this;
    }
    /**
     * Get NationalId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNationalId()
    {
        return isset($this->NationalId) ? $this->NationalId : null;
    }
    /**
     * Set NationalId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $nationalId
     * @return \StructType\DriverInfo
     */
    public function setNationalId($nationalId = null)
    {
        // validation for constraint: string
        if (!is_null($nationalId) && !is_string($nationalId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($nationalId, true), gettype($nationalId)), __LINE__);
        }
        if (is_null($nationalId) || (is_array($nationalId) && empty($nationalId))) {
            unset($this->NationalId);
        } else {
            $this->NationalId = $nationalId;
        }
        return $this;
    }
    /**
     * Get TARIKH_ETEBAR_KART_SALAMAT value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTARIKH_ETEBAR_KART_SALAMAT()
    {
        return isset($this->TARIKH_ETEBAR_KART_SALAMAT) ? $this->TARIKH_ETEBAR_KART_SALAMAT : null;
    }
    /**
     * Set TARIKH_ETEBAR_KART_SALAMAT value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $tARIKH_ETEBAR_KART_SALAMAT
     * @return \StructType\DriverInfo
     */
    public function setTARIKH_ETEBAR_KART_SALAMAT($tARIKH_ETEBAR_KART_SALAMAT = null)
    {
        // validation for constraint: string
        if (!is_null($tARIKH_ETEBAR_KART_SALAMAT) && !is_string($tARIKH_ETEBAR_KART_SALAMAT)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($tARIKH_ETEBAR_KART_SALAMAT, true), gettype($tARIKH_ETEBAR_KART_SALAMAT)), __LINE__);
        }
        if (is_null($tARIKH_ETEBAR_KART_SALAMAT) || (is_array($tARIKH_ETEBAR_KART_SALAMAT) && empty($tARIKH_ETEBAR_KART_SALAMAT))) {
            unset($this->TARIKH_ETEBAR_KART_SALAMAT);
        } else {
            $this->TARIKH_ETEBAR_KART_SALAMAT = $tARIKH_ETEBAR_KART_SALAMAT;
        }
        return $this;
    }
}
