<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for InquiryInsuranceResultCnt StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:InquiryInsuranceResultCnt
 * @subpackage Structs
 */
class InquiryInsuranceResultCnt extends AbstractStructBase
{
    /**
     * The CmpNam
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CmpNam;
    /**
     * The EndDte
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $EndDte;
    /**
     * The Endorsments
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfInquiryInsuranceEndorsmentResultCnt
     */
    public $Endorsments;
    /**
     * The ErrorCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $ErrorCode;
    /**
     * The ErrorDescription
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ErrorDescription;
    /**
     * The FldNam
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $FldNam;
    /**
     * The IsuDte
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $IsuDte;
    /**
     * The MIsuDte
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $MIsuDte;
    /**
     * The Nam
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Nam;
    /**
     * The NtlCod
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $NtlCod;
    /**
     * The PlcyDoc
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $PlcyDoc;
    /**
     * The SttDte
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $SttDte;
    /**
     * The UnqCod
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $UnqCod;
    /**
     * Constructor method for InquiryInsuranceResultCnt
     * @uses InquiryInsuranceResultCnt::setCmpNam()
     * @uses InquiryInsuranceResultCnt::setEndDte()
     * @uses InquiryInsuranceResultCnt::setEndorsments()
     * @uses InquiryInsuranceResultCnt::setErrorCode()
     * @uses InquiryInsuranceResultCnt::setErrorDescription()
     * @uses InquiryInsuranceResultCnt::setFldNam()
     * @uses InquiryInsuranceResultCnt::setIsuDte()
     * @uses InquiryInsuranceResultCnt::setMIsuDte()
     * @uses InquiryInsuranceResultCnt::setNam()
     * @uses InquiryInsuranceResultCnt::setNtlCod()
     * @uses InquiryInsuranceResultCnt::setPlcyDoc()
     * @uses InquiryInsuranceResultCnt::setSttDte()
     * @uses InquiryInsuranceResultCnt::setUnqCod()
     * @param string $cmpNam
     * @param string $endDte
     * @param \ArrayType\ArrayOfInquiryInsuranceEndorsmentResultCnt $endorsments
     * @param int $errorCode
     * @param string $errorDescription
     * @param string $fldNam
     * @param string $isuDte
     * @param string $mIsuDte
     * @param string $nam
     * @param string $ntlCod
     * @param string $plcyDoc
     * @param string $sttDte
     * @param string $unqCod
     */
    public function __construct($cmpNam = null, $endDte = null, \ArrayType\ArrayOfInquiryInsuranceEndorsmentResultCnt $endorsments = null, $errorCode = null, $errorDescription = null, $fldNam = null, $isuDte = null, $mIsuDte = null, $nam = null, $ntlCod = null, $plcyDoc = null, $sttDte = null, $unqCod = null)
    {
        $this
            ->setCmpNam($cmpNam)
            ->setEndDte($endDte)
            ->setEndorsments($endorsments)
            ->setErrorCode($errorCode)
            ->setErrorDescription($errorDescription)
            ->setFldNam($fldNam)
            ->setIsuDte($isuDte)
            ->setMIsuDte($mIsuDte)
            ->setNam($nam)
            ->setNtlCod($ntlCod)
            ->setPlcyDoc($plcyDoc)
            ->setSttDte($sttDte)
            ->setUnqCod($unqCod);
    }
    /**
     * Get CmpNam value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCmpNam()
    {
        return isset($this->CmpNam) ? $this->CmpNam : null;
    }
    /**
     * Set CmpNam value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $cmpNam
     * @return \StructType\InquiryInsuranceResultCnt
     */
    public function setCmpNam($cmpNam = null)
    {
        // validation for constraint: string
        if (!is_null($cmpNam) && !is_string($cmpNam)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cmpNam, true), gettype($cmpNam)), __LINE__);
        }
        if (is_null($cmpNam) || (is_array($cmpNam) && empty($cmpNam))) {
            unset($this->CmpNam);
        } else {
            $this->CmpNam = $cmpNam;
        }
        return $this;
    }
    /**
     * Get EndDte value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getEndDte()
    {
        return isset($this->EndDte) ? $this->EndDte : null;
    }
    /**
     * Set EndDte value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $endDte
     * @return \StructType\InquiryInsuranceResultCnt
     */
    public function setEndDte($endDte = null)
    {
        // validation for constraint: string
        if (!is_null($endDte) && !is_string($endDte)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($endDte, true), gettype($endDte)), __LINE__);
        }
        if (is_null($endDte) || (is_array($endDte) && empty($endDte))) {
            unset($this->EndDte);
        } else {
            $this->EndDte = $endDte;
        }
        return $this;
    }
    /**
     * Get Endorsments value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfInquiryInsuranceEndorsmentResultCnt|null
     */
    public function getEndorsments()
    {
        return isset($this->Endorsments) ? $this->Endorsments : null;
    }
    /**
     * Set Endorsments value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfInquiryInsuranceEndorsmentResultCnt $endorsments
     * @return \StructType\InquiryInsuranceResultCnt
     */
    public function setEndorsments(\ArrayType\ArrayOfInquiryInsuranceEndorsmentResultCnt $endorsments = null)
    {
        if (is_null($endorsments) || (is_array($endorsments) && empty($endorsments))) {
            unset($this->Endorsments);
        } else {
            $this->Endorsments = $endorsments;
        }
        return $this;
    }
    /**
     * Get ErrorCode value
     * @return int|null
     */
    public function getErrorCode()
    {
        return $this->ErrorCode;
    }
    /**
     * Set ErrorCode value
     * @param int $errorCode
     * @return \StructType\InquiryInsuranceResultCnt
     */
    public function setErrorCode($errorCode = null)
    {
        // validation for constraint: int
        if (!is_null($errorCode) && !(is_int($errorCode) || ctype_digit($errorCode))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($errorCode, true), gettype($errorCode)), __LINE__);
        }
        $this->ErrorCode = $errorCode;
        return $this;
    }
    /**
     * Get ErrorDescription value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getErrorDescription()
    {
        return isset($this->ErrorDescription) ? $this->ErrorDescription : null;
    }
    /**
     * Set ErrorDescription value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $errorDescription
     * @return \StructType\InquiryInsuranceResultCnt
     */
    public function setErrorDescription($errorDescription = null)
    {
        // validation for constraint: string
        if (!is_null($errorDescription) && !is_string($errorDescription)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($errorDescription, true), gettype($errorDescription)), __LINE__);
        }
        if (is_null($errorDescription) || (is_array($errorDescription) && empty($errorDescription))) {
            unset($this->ErrorDescription);
        } else {
            $this->ErrorDescription = $errorDescription;
        }
        return $this;
    }
    /**
     * Get FldNam value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFldNam()
    {
        return isset($this->FldNam) ? $this->FldNam : null;
    }
    /**
     * Set FldNam value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $fldNam
     * @return \StructType\InquiryInsuranceResultCnt
     */
    public function setFldNam($fldNam = null)
    {
        // validation for constraint: string
        if (!is_null($fldNam) && !is_string($fldNam)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fldNam, true), gettype($fldNam)), __LINE__);
        }
        if (is_null($fldNam) || (is_array($fldNam) && empty($fldNam))) {
            unset($this->FldNam);
        } else {
            $this->FldNam = $fldNam;
        }
        return $this;
    }
    /**
     * Get IsuDte value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getIsuDte()
    {
        return isset($this->IsuDte) ? $this->IsuDte : null;
    }
    /**
     * Set IsuDte value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $isuDte
     * @return \StructType\InquiryInsuranceResultCnt
     */
    public function setIsuDte($isuDte = null)
    {
        // validation for constraint: string
        if (!is_null($isuDte) && !is_string($isuDte)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($isuDte, true), gettype($isuDte)), __LINE__);
        }
        if (is_null($isuDte) || (is_array($isuDte) && empty($isuDte))) {
            unset($this->IsuDte);
        } else {
            $this->IsuDte = $isuDte;
        }
        return $this;
    }
    /**
     * Get MIsuDte value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMIsuDte()
    {
        return isset($this->MIsuDte) ? $this->MIsuDte : null;
    }
    /**
     * Set MIsuDte value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $mIsuDte
     * @return \StructType\InquiryInsuranceResultCnt
     */
    public function setMIsuDte($mIsuDte = null)
    {
        // validation for constraint: string
        if (!is_null($mIsuDte) && !is_string($mIsuDte)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($mIsuDte, true), gettype($mIsuDte)), __LINE__);
        }
        if (is_null($mIsuDte) || (is_array($mIsuDte) && empty($mIsuDte))) {
            unset($this->MIsuDte);
        } else {
            $this->MIsuDte = $mIsuDte;
        }
        return $this;
    }
    /**
     * Get Nam value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNam()
    {
        return isset($this->Nam) ? $this->Nam : null;
    }
    /**
     * Set Nam value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $nam
     * @return \StructType\InquiryInsuranceResultCnt
     */
    public function setNam($nam = null)
    {
        // validation for constraint: string
        if (!is_null($nam) && !is_string($nam)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($nam, true), gettype($nam)), __LINE__);
        }
        if (is_null($nam) || (is_array($nam) && empty($nam))) {
            unset($this->Nam);
        } else {
            $this->Nam = $nam;
        }
        return $this;
    }
    /**
     * Get NtlCod value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNtlCod()
    {
        return isset($this->NtlCod) ? $this->NtlCod : null;
    }
    /**
     * Set NtlCod value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $ntlCod
     * @return \StructType\InquiryInsuranceResultCnt
     */
    public function setNtlCod($ntlCod = null)
    {
        // validation for constraint: string
        if (!is_null($ntlCod) && !is_string($ntlCod)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ntlCod, true), gettype($ntlCod)), __LINE__);
        }
        if (is_null($ntlCod) || (is_array($ntlCod) && empty($ntlCod))) {
            unset($this->NtlCod);
        } else {
            $this->NtlCod = $ntlCod;
        }
        return $this;
    }
    /**
     * Get PlcyDoc value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPlcyDoc()
    {
        return isset($this->PlcyDoc) ? $this->PlcyDoc : null;
    }
    /**
     * Set PlcyDoc value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $plcyDoc
     * @return \StructType\InquiryInsuranceResultCnt
     */
    public function setPlcyDoc($plcyDoc = null)
    {
        // validation for constraint: string
        if (!is_null($plcyDoc) && !is_string($plcyDoc)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($plcyDoc, true), gettype($plcyDoc)), __LINE__);
        }
        if (is_null($plcyDoc) || (is_array($plcyDoc) && empty($plcyDoc))) {
            unset($this->PlcyDoc);
        } else {
            $this->PlcyDoc = $plcyDoc;
        }
        return $this;
    }
    /**
     * Get SttDte value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSttDte()
    {
        return isset($this->SttDte) ? $this->SttDte : null;
    }
    /**
     * Set SttDte value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $sttDte
     * @return \StructType\InquiryInsuranceResultCnt
     */
    public function setSttDte($sttDte = null)
    {
        // validation for constraint: string
        if (!is_null($sttDte) && !is_string($sttDte)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sttDte, true), gettype($sttDte)), __LINE__);
        }
        if (is_null($sttDte) || (is_array($sttDte) && empty($sttDte))) {
            unset($this->SttDte);
        } else {
            $this->SttDte = $sttDte;
        }
        return $this;
    }
    /**
     * Get UnqCod value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUnqCod()
    {
        return isset($this->UnqCod) ? $this->UnqCod : null;
    }
    /**
     * Set UnqCod value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $unqCod
     * @return \StructType\InquiryInsuranceResultCnt
     */
    public function setUnqCod($unqCod = null)
    {
        // validation for constraint: string
        if (!is_null($unqCod) && !is_string($unqCod)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($unqCod, true), gettype($unqCod)), __LINE__);
        }
        if (is_null($unqCod) || (is_array($unqCod) && empty($unqCod))) {
            unset($this->UnqCod);
        } else {
            $this->UnqCod = $unqCod;
        }
        return $this;
    }
}
