<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for InquiryResponse StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:InquiryResponse
 * @subpackage Structs
 */
class InquiryResponse extends AbstractStructBase
{
    /**
     * The CorrectReceiverInfo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PersonInfo
     */
    public $CorrectReceiverInfo;
    /**
     * The CorrectSenderInfo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PersonInfo
     */
    public $CorrectSenderInfo;
    /**
     * The FirsDriverInfo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DriverInfo
     */
    public $FirsDriverInfo;
    /**
     * The FreighterInfo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\FreighterInfo
     */
    public $FreighterInfo;
    /**
     * The GoodInfoList
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfGoodFullInfo
     */
    public $GoodInfoList;
    /**
     * The SecondDriverInfo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DriverInfo
     */
    public $SecondDriverInfo;
    /**
     * The TraceCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $TraceCode;
    /**
     * The WarningMessage
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $WarningMessage;
    /**
     * Constructor method for InquiryResponse
     * @uses InquiryResponse::setCorrectReceiverInfo()
     * @uses InquiryResponse::setCorrectSenderInfo()
     * @uses InquiryResponse::setFirsDriverInfo()
     * @uses InquiryResponse::setFreighterInfo()
     * @uses InquiryResponse::setGoodInfoList()
     * @uses InquiryResponse::setSecondDriverInfo()
     * @uses InquiryResponse::setTraceCode()
     * @uses InquiryResponse::setWarningMessage()
     * @param \StructType\PersonInfo $correctReceiverInfo
     * @param \StructType\PersonInfo $correctSenderInfo
     * @param \StructType\DriverInfo $firsDriverInfo
     * @param \StructType\FreighterInfo $freighterInfo
     * @param \ArrayType\ArrayOfGoodFullInfo $goodInfoList
     * @param \StructType\DriverInfo $secondDriverInfo
     * @param string $traceCode
     * @param string $warningMessage
     */
    public function __construct(\StructType\PersonInfo $correctReceiverInfo = null, \StructType\PersonInfo $correctSenderInfo = null, \StructType\DriverInfo $firsDriverInfo = null, \StructType\FreighterInfo $freighterInfo = null, \ArrayType\ArrayOfGoodFullInfo $goodInfoList = null, \StructType\DriverInfo $secondDriverInfo = null, $traceCode = null, $warningMessage = null)
    {
        $this
            ->setCorrectReceiverInfo($correctReceiverInfo)
            ->setCorrectSenderInfo($correctSenderInfo)
            ->setFirsDriverInfo($firsDriverInfo)
            ->setFreighterInfo($freighterInfo)
            ->setGoodInfoList($goodInfoList)
            ->setSecondDriverInfo($secondDriverInfo)
            ->setTraceCode($traceCode)
            ->setWarningMessage($warningMessage);
    }
    /**
     * Get CorrectReceiverInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PersonInfo|null
     */
    public function getCorrectReceiverInfo()
    {
        return isset($this->CorrectReceiverInfo) ? $this->CorrectReceiverInfo : null;
    }
    /**
     * Set CorrectReceiverInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\PersonInfo $correctReceiverInfo
     * @return \StructType\InquiryResponse
     */
    public function setCorrectReceiverInfo(\StructType\PersonInfo $correctReceiverInfo = null)
    {
        if (is_null($correctReceiverInfo) || (is_array($correctReceiverInfo) && empty($correctReceiverInfo))) {
            unset($this->CorrectReceiverInfo);
        } else {
            $this->CorrectReceiverInfo = $correctReceiverInfo;
        }
        return $this;
    }
    /**
     * Get CorrectSenderInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PersonInfo|null
     */
    public function getCorrectSenderInfo()
    {
        return isset($this->CorrectSenderInfo) ? $this->CorrectSenderInfo : null;
    }
    /**
     * Set CorrectSenderInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\PersonInfo $correctSenderInfo
     * @return \StructType\InquiryResponse
     */
    public function setCorrectSenderInfo(\StructType\PersonInfo $correctSenderInfo = null)
    {
        if (is_null($correctSenderInfo) || (is_array($correctSenderInfo) && empty($correctSenderInfo))) {
            unset($this->CorrectSenderInfo);
        } else {
            $this->CorrectSenderInfo = $correctSenderInfo;
        }
        return $this;
    }
    /**
     * Get FirsDriverInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DriverInfo|null
     */
    public function getFirsDriverInfo()
    {
        return isset($this->FirsDriverInfo) ? $this->FirsDriverInfo : null;
    }
    /**
     * Set FirsDriverInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DriverInfo $firsDriverInfo
     * @return \StructType\InquiryResponse
     */
    public function setFirsDriverInfo(\StructType\DriverInfo $firsDriverInfo = null)
    {
        if (is_null($firsDriverInfo) || (is_array($firsDriverInfo) && empty($firsDriverInfo))) {
            unset($this->FirsDriverInfo);
        } else {
            $this->FirsDriverInfo = $firsDriverInfo;
        }
        return $this;
    }
    /**
     * Get FreighterInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\FreighterInfo|null
     */
    public function getFreighterInfo()
    {
        return isset($this->FreighterInfo) ? $this->FreighterInfo : null;
    }
    /**
     * Set FreighterInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\FreighterInfo $freighterInfo
     * @return \StructType\InquiryResponse
     */
    public function setFreighterInfo(\StructType\FreighterInfo $freighterInfo = null)
    {
        if (is_null($freighterInfo) || (is_array($freighterInfo) && empty($freighterInfo))) {
            unset($this->FreighterInfo);
        } else {
            $this->FreighterInfo = $freighterInfo;
        }
        return $this;
    }
    /**
     * Get GoodInfoList value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfGoodFullInfo|null
     */
    public function getGoodInfoList()
    {
        return isset($this->GoodInfoList) ? $this->GoodInfoList : null;
    }
    /**
     * Set GoodInfoList value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfGoodFullInfo $goodInfoList
     * @return \StructType\InquiryResponse
     */
    public function setGoodInfoList(\ArrayType\ArrayOfGoodFullInfo $goodInfoList = null)
    {
        if (is_null($goodInfoList) || (is_array($goodInfoList) && empty($goodInfoList))) {
            unset($this->GoodInfoList);
        } else {
            $this->GoodInfoList = $goodInfoList;
        }
        return $this;
    }
    /**
     * Get SecondDriverInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DriverInfo|null
     */
    public function getSecondDriverInfo()
    {
        return isset($this->SecondDriverInfo) ? $this->SecondDriverInfo : null;
    }
    /**
     * Set SecondDriverInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DriverInfo $secondDriverInfo
     * @return \StructType\InquiryResponse
     */
    public function setSecondDriverInfo(\StructType\DriverInfo $secondDriverInfo = null)
    {
        if (is_null($secondDriverInfo) || (is_array($secondDriverInfo) && empty($secondDriverInfo))) {
            unset($this->SecondDriverInfo);
        } else {
            $this->SecondDriverInfo = $secondDriverInfo;
        }
        return $this;
    }
    /**
     * Get TraceCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTraceCode()
    {
        return isset($this->TraceCode) ? $this->TraceCode : null;
    }
    /**
     * Set TraceCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $traceCode
     * @return \StructType\InquiryResponse
     */
    public function setTraceCode($traceCode = null)
    {
        // validation for constraint: string
        if (!is_null($traceCode) && !is_string($traceCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($traceCode, true), gettype($traceCode)), __LINE__);
        }
        if (is_null($traceCode) || (is_array($traceCode) && empty($traceCode))) {
            unset($this->TraceCode);
        } else {
            $this->TraceCode = $traceCode;
        }
        return $this;
    }
    /**
     * Get WarningMessage value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getWarningMessage()
    {
        return isset($this->WarningMessage) ? $this->WarningMessage : null;
    }
    /**
     * Set WarningMessage value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $warningMessage
     * @return \StructType\InquiryResponse
     */
    public function setWarningMessage($warningMessage = null)
    {
        // validation for constraint: string
        if (!is_null($warningMessage) && !is_string($warningMessage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($warningMessage, true), gettype($warningMessage)), __LINE__);
        }
        if (is_null($warningMessage) || (is_array($warningMessage) && empty($warningMessage))) {
            unset($this->WarningMessage);
        } else {
            $this->WarningMessage = $warningMessage;
        }
        return $this;
    }
}
