<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for InquiryResultCnt StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:InquiryResultCnt
 * @subpackage Structs
 */
class InquiryResultCnt extends AbstractStructBase
{
    /**
     * The ErrorDesc
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ErrorDesc;
    /**
     * The FullAddress
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $FullAddress;
    /**
     * The IsSuccessful
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $IsSuccessful;
    /**
     * The LastName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $LastName;
    /**
     * The Name
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Name;
    /**
     * The SuccessfulDesc
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $SuccessfulDesc;
    /**
     * The WarningDesc
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $WarningDesc;
    /**
     * Constructor method for InquiryResultCnt
     * @uses InquiryResultCnt::setErrorDesc()
     * @uses InquiryResultCnt::setFullAddress()
     * @uses InquiryResultCnt::setIsSuccessful()
     * @uses InquiryResultCnt::setLastName()
     * @uses InquiryResultCnt::setName()
     * @uses InquiryResultCnt::setSuccessfulDesc()
     * @uses InquiryResultCnt::setWarningDesc()
     * @param string $errorDesc
     * @param string $fullAddress
     * @param bool $isSuccessful
     * @param string $lastName
     * @param string $name
     * @param string $successfulDesc
     * @param string $warningDesc
     */
    public function __construct($errorDesc = null, $fullAddress = null, $isSuccessful = null, $lastName = null, $name = null, $successfulDesc = null, $warningDesc = null)
    {
        $this
            ->setErrorDesc($errorDesc)
            ->setFullAddress($fullAddress)
            ->setIsSuccessful($isSuccessful)
            ->setLastName($lastName)
            ->setName($name)
            ->setSuccessfulDesc($successfulDesc)
            ->setWarningDesc($warningDesc);
    }
    /**
     * Get ErrorDesc value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getErrorDesc()
    {
        return isset($this->ErrorDesc) ? $this->ErrorDesc : null;
    }
    /**
     * Set ErrorDesc value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $errorDesc
     * @return \StructType\InquiryResultCnt
     */
    public function setErrorDesc($errorDesc = null)
    {
        // validation for constraint: string
        if (!is_null($errorDesc) && !is_string($errorDesc)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($errorDesc, true), gettype($errorDesc)), __LINE__);
        }
        if (is_null($errorDesc) || (is_array($errorDesc) && empty($errorDesc))) {
            unset($this->ErrorDesc);
        } else {
            $this->ErrorDesc = $errorDesc;
        }
        return $this;
    }
    /**
     * Get FullAddress value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFullAddress()
    {
        return isset($this->FullAddress) ? $this->FullAddress : null;
    }
    /**
     * Set FullAddress value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $fullAddress
     * @return \StructType\InquiryResultCnt
     */
    public function setFullAddress($fullAddress = null)
    {
        // validation for constraint: string
        if (!is_null($fullAddress) && !is_string($fullAddress)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fullAddress, true), gettype($fullAddress)), __LINE__);
        }
        if (is_null($fullAddress) || (is_array($fullAddress) && empty($fullAddress))) {
            unset($this->FullAddress);
        } else {
            $this->FullAddress = $fullAddress;
        }
        return $this;
    }
    /**
     * Get IsSuccessful value
     * @return bool|null
     */
    public function getIsSuccessful()
    {
        return $this->IsSuccessful;
    }
    /**
     * Set IsSuccessful value
     * @param bool $isSuccessful
     * @return \StructType\InquiryResultCnt
     */
    public function setIsSuccessful($isSuccessful = null)
    {
        // validation for constraint: boolean
        if (!is_null($isSuccessful) && !is_bool($isSuccessful)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isSuccessful, true), gettype($isSuccessful)), __LINE__);
        }
        $this->IsSuccessful = $isSuccessful;
        return $this;
    }
    /**
     * Get LastName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLastName()
    {
        return isset($this->LastName) ? $this->LastName : null;
    }
    /**
     * Set LastName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $lastName
     * @return \StructType\InquiryResultCnt
     */
    public function setLastName($lastName = null)
    {
        // validation for constraint: string
        if (!is_null($lastName) && !is_string($lastName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($lastName, true), gettype($lastName)), __LINE__);
        }
        if (is_null($lastName) || (is_array($lastName) && empty($lastName))) {
            unset($this->LastName);
        } else {
            $this->LastName = $lastName;
        }
        return $this;
    }
    /**
     * Get Name value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getName()
    {
        return isset($this->Name) ? $this->Name : null;
    }
    /**
     * Set Name value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $name
     * @return \StructType\InquiryResultCnt
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        if (is_null($name) || (is_array($name) && empty($name))) {
            unset($this->Name);
        } else {
            $this->Name = $name;
        }
        return $this;
    }
    /**
     * Get SuccessfulDesc value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSuccessfulDesc()
    {
        return isset($this->SuccessfulDesc) ? $this->SuccessfulDesc : null;
    }
    /**
     * Set SuccessfulDesc value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $successfulDesc
     * @return \StructType\InquiryResultCnt
     */
    public function setSuccessfulDesc($successfulDesc = null)
    {
        // validation for constraint: string
        if (!is_null($successfulDesc) && !is_string($successfulDesc)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($successfulDesc, true), gettype($successfulDesc)), __LINE__);
        }
        if (is_null($successfulDesc) || (is_array($successfulDesc) && empty($successfulDesc))) {
            unset($this->SuccessfulDesc);
        } else {
            $this->SuccessfulDesc = $successfulDesc;
        }
        return $this;
    }
    /**
     * Get WarningDesc value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getWarningDesc()
    {
        return isset($this->WarningDesc) ? $this->WarningDesc : null;
    }
    /**
     * Set WarningDesc value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $warningDesc
     * @return \StructType\InquiryResultCnt
     */
    public function setWarningDesc($warningDesc = null)
    {
        // validation for constraint: string
        if (!is_null($warningDesc) && !is_string($warningDesc)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($warningDesc, true), gettype($warningDesc)), __LINE__);
        }
        if (is_null($warningDesc) || (is_array($warningDesc) && empty($warningDesc))) {
            unset($this->WarningDesc);
        } else {
            $this->WarningDesc = $warningDesc;
        }
        return $this;
    }
}
