<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TradeDocInformationCnt StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:TradeDocInformationCnt
 * @subpackage Structs
 */
class TradeDocInformationCnt extends AbstractStructBase
{
    /**
     * The ContainersCount
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ContainersCount;
    /**
     * The ContainersList
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfTradeDocInformationContainerCnt
     */
    public $ContainersList;
    /**
     * The DischargePostalCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $DischargePostalCode;
    /**
     * The DriverName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $DriverName;
    /**
     * The DriverNationalCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $DriverNationalCode;
    /**
     * The Error_Code
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $Error_Code;
    /**
     * The Error_Message
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Error_Message;
    /**
     * The GoodsValue
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $GoodsValue;
    /**
     * The GrossWeight
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $GrossWeight;
    /**
     * The LoadingDateTime
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $LoadingDateTime;
    /**
     * The LoadingPostalCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $LoadingPostalCode;
    /**
     * The NetWeight
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $NetWeight;
    /**
     * The PackageCount
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $PackageCount;
    /**
     * The ReceiverName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ReceiverName;
    /**
     * The ReceiverNationalCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ReceiverNationalCode;
    /**
     * The RegistrationDate
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $RegistrationDate;
    /**
     * The SenderName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $SenderName;
    /**
     * The SenderNationalCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $SenderNationalCode;
    /**
     * The VesselRegistrationNumber
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $VesselRegistrationNumber;
    /**
     * The listGoods
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfTradeDocInformationGoodsCnt
     */
    public $listGoods;
    /**
     * Constructor method for TradeDocInformationCnt
     * @uses TradeDocInformationCnt::setContainersCount()
     * @uses TradeDocInformationCnt::setContainersList()
     * @uses TradeDocInformationCnt::setDischargePostalCode()
     * @uses TradeDocInformationCnt::setDriverName()
     * @uses TradeDocInformationCnt::setDriverNationalCode()
     * @uses TradeDocInformationCnt::setError_Code()
     * @uses TradeDocInformationCnt::setError_Message()
     * @uses TradeDocInformationCnt::setGoodsValue()
     * @uses TradeDocInformationCnt::setGrossWeight()
     * @uses TradeDocInformationCnt::setLoadingDateTime()
     * @uses TradeDocInformationCnt::setLoadingPostalCode()
     * @uses TradeDocInformationCnt::setNetWeight()
     * @uses TradeDocInformationCnt::setPackageCount()
     * @uses TradeDocInformationCnt::setReceiverName()
     * @uses TradeDocInformationCnt::setReceiverNationalCode()
     * @uses TradeDocInformationCnt::setRegistrationDate()
     * @uses TradeDocInformationCnt::setSenderName()
     * @uses TradeDocInformationCnt::setSenderNationalCode()
     * @uses TradeDocInformationCnt::setVesselRegistrationNumber()
     * @uses TradeDocInformationCnt::setListGoods()
     * @param string $containersCount
     * @param \ArrayType\ArrayOfTradeDocInformationContainerCnt $containersList
     * @param string $dischargePostalCode
     * @param string $driverName
     * @param string $driverNationalCode
     * @param int $error_Code
     * @param string $error_Message
     * @param string $goodsValue
     * @param string $grossWeight
     * @param int $loadingDateTime
     * @param string $loadingPostalCode
     * @param string $netWeight
     * @param string $packageCount
     * @param string $receiverName
     * @param string $receiverNationalCode
     * @param int $registrationDate
     * @param string $senderName
     * @param string $senderNationalCode
     * @param string $vesselRegistrationNumber
     * @param \ArrayType\ArrayOfTradeDocInformationGoodsCnt $listGoods
     */
    public function __construct($containersCount = null, \ArrayType\ArrayOfTradeDocInformationContainerCnt $containersList = null, $dischargePostalCode = null, $driverName = null, $driverNationalCode = null, $error_Code = null, $error_Message = null, $goodsValue = null, $grossWeight = null, $loadingDateTime = null, $loadingPostalCode = null, $netWeight = null, $packageCount = null, $receiverName = null, $receiverNationalCode = null, $registrationDate = null, $senderName = null, $senderNationalCode = null, $vesselRegistrationNumber = null, \ArrayType\ArrayOfTradeDocInformationGoodsCnt $listGoods = null)
    {
        $this
            ->setContainersCount($containersCount)
            ->setContainersList($containersList)
            ->setDischargePostalCode($dischargePostalCode)
            ->setDriverName($driverName)
            ->setDriverNationalCode($driverNationalCode)
            ->setError_Code($error_Code)
            ->setError_Message($error_Message)
            ->setGoodsValue($goodsValue)
            ->setGrossWeight($grossWeight)
            ->setLoadingDateTime($loadingDateTime)
            ->setLoadingPostalCode($loadingPostalCode)
            ->setNetWeight($netWeight)
            ->setPackageCount($packageCount)
            ->setReceiverName($receiverName)
            ->setReceiverNationalCode($receiverNationalCode)
            ->setRegistrationDate($registrationDate)
            ->setSenderName($senderName)
            ->setSenderNationalCode($senderNationalCode)
            ->setVesselRegistrationNumber($vesselRegistrationNumber)
            ->setListGoods($listGoods);
    }
    /**
     * Get ContainersCount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getContainersCount()
    {
        return isset($this->ContainersCount) ? $this->ContainersCount : null;
    }
    /**
     * Set ContainersCount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $containersCount
     * @return \StructType\TradeDocInformationCnt
     */
    public function setContainersCount($containersCount = null)
    {
        // validation for constraint: string
        if (!is_null($containersCount) && !is_string($containersCount)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($containersCount, true), gettype($containersCount)), __LINE__);
        }
        if (is_null($containersCount) || (is_array($containersCount) && empty($containersCount))) {
            unset($this->ContainersCount);
        } else {
            $this->ContainersCount = $containersCount;
        }
        return $this;
    }
    /**
     * Get ContainersList value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfTradeDocInformationContainerCnt|null
     */
    public function getContainersList()
    {
        return isset($this->ContainersList) ? $this->ContainersList : null;
    }
    /**
     * Set ContainersList value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfTradeDocInformationContainerCnt $containersList
     * @return \StructType\TradeDocInformationCnt
     */
    public function setContainersList(\ArrayType\ArrayOfTradeDocInformationContainerCnt $containersList = null)
    {
        if (is_null($containersList) || (is_array($containersList) && empty($containersList))) {
            unset($this->ContainersList);
        } else {
            $this->ContainersList = $containersList;
        }
        return $this;
    }
    /**
     * Get DischargePostalCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDischargePostalCode()
    {
        return isset($this->DischargePostalCode) ? $this->DischargePostalCode : null;
    }
    /**
     * Set DischargePostalCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $dischargePostalCode
     * @return \StructType\TradeDocInformationCnt
     */
    public function setDischargePostalCode($dischargePostalCode = null)
    {
        // validation for constraint: string
        if (!is_null($dischargePostalCode) && !is_string($dischargePostalCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dischargePostalCode, true), gettype($dischargePostalCode)), __LINE__);
        }
        if (is_null($dischargePostalCode) || (is_array($dischargePostalCode) && empty($dischargePostalCode))) {
            unset($this->DischargePostalCode);
        } else {
            $this->DischargePostalCode = $dischargePostalCode;
        }
        return $this;
    }
    /**
     * Get DriverName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDriverName()
    {
        return isset($this->DriverName) ? $this->DriverName : null;
    }
    /**
     * Set DriverName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $driverName
     * @return \StructType\TradeDocInformationCnt
     */
    public function setDriverName($driverName = null)
    {
        // validation for constraint: string
        if (!is_null($driverName) && !is_string($driverName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($driverName, true), gettype($driverName)), __LINE__);
        }
        if (is_null($driverName) || (is_array($driverName) && empty($driverName))) {
            unset($this->DriverName);
        } else {
            $this->DriverName = $driverName;
        }
        return $this;
    }
    /**
     * Get DriverNationalCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDriverNationalCode()
    {
        return isset($this->DriverNationalCode) ? $this->DriverNationalCode : null;
    }
    /**
     * Set DriverNationalCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $driverNationalCode
     * @return \StructType\TradeDocInformationCnt
     */
    public function setDriverNationalCode($driverNationalCode = null)
    {
        // validation for constraint: string
        if (!is_null($driverNationalCode) && !is_string($driverNationalCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($driverNationalCode, true), gettype($driverNationalCode)), __LINE__);
        }
        if (is_null($driverNationalCode) || (is_array($driverNationalCode) && empty($driverNationalCode))) {
            unset($this->DriverNationalCode);
        } else {
            $this->DriverNationalCode = $driverNationalCode;
        }
        return $this;
    }
    /**
     * Get Error_Code value
     * @return int|null
     */
    public function getError_Code()
    {
        return $this->Error_Code;
    }
    /**
     * Set Error_Code value
     * @param int $error_Code
     * @return \StructType\TradeDocInformationCnt
     */
    public function setError_Code($error_Code = null)
    {
        // validation for constraint: int
        if (!is_null($error_Code) && !(is_int($error_Code) || ctype_digit($error_Code))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($error_Code, true), gettype($error_Code)), __LINE__);
        }
        $this->Error_Code = $error_Code;
        return $this;
    }
    /**
     * Get Error_Message value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getError_Message()
    {
        return isset($this->Error_Message) ? $this->Error_Message : null;
    }
    /**
     * Set Error_Message value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $error_Message
     * @return \StructType\TradeDocInformationCnt
     */
    public function setError_Message($error_Message = null)
    {
        // validation for constraint: string
        if (!is_null($error_Message) && !is_string($error_Message)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($error_Message, true), gettype($error_Message)), __LINE__);
        }
        if (is_null($error_Message) || (is_array($error_Message) && empty($error_Message))) {
            unset($this->Error_Message);
        } else {
            $this->Error_Message = $error_Message;
        }
        return $this;
    }
    /**
     * Get GoodsValue value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getGoodsValue()
    {
        return isset($this->GoodsValue) ? $this->GoodsValue : null;
    }
    /**
     * Set GoodsValue value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $goodsValue
     * @return \StructType\TradeDocInformationCnt
     */
    public function setGoodsValue($goodsValue = null)
    {
        // validation for constraint: string
        if (!is_null($goodsValue) && !is_string($goodsValue)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($goodsValue, true), gettype($goodsValue)), __LINE__);
        }
        if (is_null($goodsValue) || (is_array($goodsValue) && empty($goodsValue))) {
            unset($this->GoodsValue);
        } else {
            $this->GoodsValue = $goodsValue;
        }
        return $this;
    }
    /**
     * Get GrossWeight value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getGrossWeight()
    {
        return isset($this->GrossWeight) ? $this->GrossWeight : null;
    }
    /**
     * Set GrossWeight value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $grossWeight
     * @return \StructType\TradeDocInformationCnt
     */
    public function setGrossWeight($grossWeight = null)
    {
        // validation for constraint: string
        if (!is_null($grossWeight) && !is_string($grossWeight)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($grossWeight, true), gettype($grossWeight)), __LINE__);
        }
        if (is_null($grossWeight) || (is_array($grossWeight) && empty($grossWeight))) {
            unset($this->GrossWeight);
        } else {
            $this->GrossWeight = $grossWeight;
        }
        return $this;
    }
    /**
     * Get LoadingDateTime value
     * @return int|null
     */
    public function getLoadingDateTime()
    {
        return $this->LoadingDateTime;
    }
    /**
     * Set LoadingDateTime value
     * @param int $loadingDateTime
     * @return \StructType\TradeDocInformationCnt
     */
    public function setLoadingDateTime($loadingDateTime = null)
    {
        // validation for constraint: int
        if (!is_null($loadingDateTime) && !(is_int($loadingDateTime) || ctype_digit($loadingDateTime))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($loadingDateTime, true), gettype($loadingDateTime)), __LINE__);
        }
        $this->LoadingDateTime = $loadingDateTime;
        return $this;
    }
    /**
     * Get LoadingPostalCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLoadingPostalCode()
    {
        return isset($this->LoadingPostalCode) ? $this->LoadingPostalCode : null;
    }
    /**
     * Set LoadingPostalCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $loadingPostalCode
     * @return \StructType\TradeDocInformationCnt
     */
    public function setLoadingPostalCode($loadingPostalCode = null)
    {
        // validation for constraint: string
        if (!is_null($loadingPostalCode) && !is_string($loadingPostalCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($loadingPostalCode, true), gettype($loadingPostalCode)), __LINE__);
        }
        if (is_null($loadingPostalCode) || (is_array($loadingPostalCode) && empty($loadingPostalCode))) {
            unset($this->LoadingPostalCode);
        } else {
            $this->LoadingPostalCode = $loadingPostalCode;
        }
        return $this;
    }
    /**
     * Get NetWeight value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNetWeight()
    {
        return isset($this->NetWeight) ? $this->NetWeight : null;
    }
    /**
     * Set NetWeight value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $netWeight
     * @return \StructType\TradeDocInformationCnt
     */
    public function setNetWeight($netWeight = null)
    {
        // validation for constraint: string
        if (!is_null($netWeight) && !is_string($netWeight)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($netWeight, true), gettype($netWeight)), __LINE__);
        }
        if (is_null($netWeight) || (is_array($netWeight) && empty($netWeight))) {
            unset($this->NetWeight);
        } else {
            $this->NetWeight = $netWeight;
        }
        return $this;
    }
    /**
     * Get PackageCount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPackageCount()
    {
        return isset($this->PackageCount) ? $this->PackageCount : null;
    }
    /**
     * Set PackageCount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $packageCount
     * @return \StructType\TradeDocInformationCnt
     */
    public function setPackageCount($packageCount = null)
    {
        // validation for constraint: string
        if (!is_null($packageCount) && !is_string($packageCount)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($packageCount, true), gettype($packageCount)), __LINE__);
        }
        if (is_null($packageCount) || (is_array($packageCount) && empty($packageCount))) {
            unset($this->PackageCount);
        } else {
            $this->PackageCount = $packageCount;
        }
        return $this;
    }
    /**
     * Get ReceiverName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getReceiverName()
    {
        return isset($this->ReceiverName) ? $this->ReceiverName : null;
    }
    /**
     * Set ReceiverName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $receiverName
     * @return \StructType\TradeDocInformationCnt
     */
    public function setReceiverName($receiverName = null)
    {
        // validation for constraint: string
        if (!is_null($receiverName) && !is_string($receiverName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($receiverName, true), gettype($receiverName)), __LINE__);
        }
        if (is_null($receiverName) || (is_array($receiverName) && empty($receiverName))) {
            unset($this->ReceiverName);
        } else {
            $this->ReceiverName = $receiverName;
        }
        return $this;
    }
    /**
     * Get ReceiverNationalCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getReceiverNationalCode()
    {
        return isset($this->ReceiverNationalCode) ? $this->ReceiverNationalCode : null;
    }
    /**
     * Set ReceiverNationalCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $receiverNationalCode
     * @return \StructType\TradeDocInformationCnt
     */
    public function setReceiverNationalCode($receiverNationalCode = null)
    {
        // validation for constraint: string
        if (!is_null($receiverNationalCode) && !is_string($receiverNationalCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($receiverNationalCode, true), gettype($receiverNationalCode)), __LINE__);
        }
        if (is_null($receiverNationalCode) || (is_array($receiverNationalCode) && empty($receiverNationalCode))) {
            unset($this->ReceiverNationalCode);
        } else {
            $this->ReceiverNationalCode = $receiverNationalCode;
        }
        return $this;
    }
    /**
     * Get RegistrationDate value
     * @return int|null
     */
    public function getRegistrationDate()
    {
        return $this->RegistrationDate;
    }
    /**
     * Set RegistrationDate value
     * @param int $registrationDate
     * @return \StructType\TradeDocInformationCnt
     */
    public function setRegistrationDate($registrationDate = null)
    {
        // validation for constraint: int
        if (!is_null($registrationDate) && !(is_int($registrationDate) || ctype_digit($registrationDate))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($registrationDate, true), gettype($registrationDate)), __LINE__);
        }
        $this->RegistrationDate = $registrationDate;
        return $this;
    }
    /**
     * Get SenderName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSenderName()
    {
        return isset($this->SenderName) ? $this->SenderName : null;
    }
    /**
     * Set SenderName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $senderName
     * @return \StructType\TradeDocInformationCnt
     */
    public function setSenderName($senderName = null)
    {
        // validation for constraint: string
        if (!is_null($senderName) && !is_string($senderName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($senderName, true), gettype($senderName)), __LINE__);
        }
        if (is_null($senderName) || (is_array($senderName) && empty($senderName))) {
            unset($this->SenderName);
        } else {
            $this->SenderName = $senderName;
        }
        return $this;
    }
    /**
     * Get SenderNationalCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSenderNationalCode()
    {
        return isset($this->SenderNationalCode) ? $this->SenderNationalCode : null;
    }
    /**
     * Set SenderNationalCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $senderNationalCode
     * @return \StructType\TradeDocInformationCnt
     */
    public function setSenderNationalCode($senderNationalCode = null)
    {
        // validation for constraint: string
        if (!is_null($senderNationalCode) && !is_string($senderNationalCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($senderNationalCode, true), gettype($senderNationalCode)), __LINE__);
        }
        if (is_null($senderNationalCode) || (is_array($senderNationalCode) && empty($senderNationalCode))) {
            unset($this->SenderNationalCode);
        } else {
            $this->SenderNationalCode = $senderNationalCode;
        }
        return $this;
    }
    /**
     * Get VesselRegistrationNumber value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getVesselRegistrationNumber()
    {
        return isset($this->VesselRegistrationNumber) ? $this->VesselRegistrationNumber : null;
    }
    /**
     * Set VesselRegistrationNumber value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $vesselRegistrationNumber
     * @return \StructType\TradeDocInformationCnt
     */
    public function setVesselRegistrationNumber($vesselRegistrationNumber = null)
    {
        // validation for constraint: string
        if (!is_null($vesselRegistrationNumber) && !is_string($vesselRegistrationNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($vesselRegistrationNumber, true), gettype($vesselRegistrationNumber)), __LINE__);
        }
        if (is_null($vesselRegistrationNumber) || (is_array($vesselRegistrationNumber) && empty($vesselRegistrationNumber))) {
            unset($this->VesselRegistrationNumber);
        } else {
            $this->VesselRegistrationNumber = $vesselRegistrationNumber;
        }
        return $this;
    }
    /**
     * Get listGoods value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfTradeDocInformationGoodsCnt|null
     */
    public function getListGoods()
    {
        return isset($this->listGoods) ? $this->listGoods : null;
    }
    /**
     * Set listGoods value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfTradeDocInformationGoodsCnt $listGoods
     * @return \StructType\TradeDocInformationCnt
     */
    public function setListGoods(\ArrayType\ArrayOfTradeDocInformationGoodsCnt $listGoods = null)
    {
        if (is_null($listGoods) || (is_array($listGoods) && empty($listGoods))) {
            unset($this->listGoods);
        } else {
            $this->listGoods = $listGoods;
        }
        return $this;
    }
}
