<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ValidationFault StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ValidationFault
 * @subpackage Structs
 */
class ValidationFault extends AbstractStructBase
{
    /**
     * The Message
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Message;
    /**
     * The ValidaitonFaultItems
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfValidaitonFaultItem
     */
    public $ValidaitonFaultItems;
    /**
     * Constructor method for ValidationFault
     * @uses ValidationFault::setMessage()
     * @uses ValidationFault::setValidaitonFaultItems()
     * @param string $message
     * @param \ArrayType\ArrayOfValidaitonFaultItem $validaitonFaultItems
     */
    public function __construct($message = null, \ArrayType\ArrayOfValidaitonFaultItem $validaitonFaultItems = null)
    {
        $this
            ->setMessage($message)
            ->setValidaitonFaultItems($validaitonFaultItems);
    }
    /**
     * Get Message value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMessage()
    {
        return isset($this->Message) ? $this->Message : null;
    }
    /**
     * Set Message value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $message
     * @return \StructType\ValidationFault
     */
    public function setMessage($message = null)
    {
        // validation for constraint: string
        if (!is_null($message) && !is_string($message)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($message, true), gettype($message)), __LINE__);
        }
        if (is_null($message) || (is_array($message) && empty($message))) {
            unset($this->Message);
        } else {
            $this->Message = $message;
        }
        return $this;
    }
    /**
     * Get ValidaitonFaultItems value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfValidaitonFaultItem|null
     */
    public function getValidaitonFaultItems()
    {
        return isset($this->ValidaitonFaultItems) ? $this->ValidaitonFaultItems : null;
    }
    /**
     * Set ValidaitonFaultItems value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfValidaitonFaultItem $validaitonFaultItems
     * @return \StructType\ValidationFault
     */
    public function setValidaitonFaultItems(\ArrayType\ArrayOfValidaitonFaultItem $validaitonFaultItems = null)
    {
        if (is_null($validaitonFaultItems) || (is_array($validaitonFaultItems) && empty($validaitonFaultItems))) {
            unset($this->ValidaitonFaultItems);
        } else {
            $this->ValidaitonFaultItems = $validaitonFaultItems;
        }
        return $this;
    }
}
